unit Unit1;
//http://www.phidels.com
// pour plus de renseignements aller sur le site openoffice.org
//par exemple  http://api.openoffice.org/basic/man/tutorial/tutorial.pdf
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  //  ajouter :
  ComObj
    ;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ButtonNouveauDocument: TButton;
    ButtonSeConnecter: TButton;
    TabSheet2: TTabSheet;
    RecupererLeTexte: TButton;
    ButtonEcriretexte: TButton;
    Memo1: TMemo;
    ButtonOuvrirDocumentExistant: TButton;
    ButtonEnregistrerSous: TButton;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ButtonImprimerSurimprimantePqarDefaut: TButton;
    ButtonImprimerPage1Et2: TButton;
    Button2: TButton;
    procedure ButtonSeConnecterClick(Sender: TObject);
    procedure ButtonNouveauDocumentClick(Sender: TObject);
    procedure RecupererLeTexteClick(Sender: TObject);
    procedure ButtonEcriretexteClick(Sender: TObject);
    procedure ButtonOuvrirDocumentExistantClick(Sender: TObject);
    procedure ButtonEnregistrerSousClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButtonImprimerSurimprimantePqarDefautClick(Sender: TObject);
    procedure ButtonImprimerPage1Et2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  ServeurOpenOffice:Variant;
  DocumentOpenOffice:Variant;



implementation

{$R *.dfm}
function SeConnecterOpenOffice: variant;
{connection  OpenOfice}
begin
  Result := CreateOleObject('com.sun.star.ServiceManager');
end;


procedure SeDeConnecterOpenOffice(var ServeurOpenOffice:variant);
begin
  ServeurOpenOffice:=Unassigned;
end;



procedure TForm1.ButtonSeConnecterClick(Sender: TObject);

begin
   ServeurOpenOffice:=SeConnecterOpenOffice;
end;

procedure TForm1.ButtonNouveauDocumentClick(Sender: TObject);
var
    OpenOfficeDesktop : Variant;
begin
  //si on se s'est pas dj connect au serveur, on le fait
   if VarIsEmpty(ServeurOpenOffice) then ServeurOpenOffice:=SeConnecterOpenOffice;
   OpenOfficeDesktop :=
      ServeurOpenOffice.createInstance('com.sun.star.frame.Desktop');
   DocumentOpenOffice :=
      OpenOfficeDesktop.LoadComponentFromURL( 'private:factory/swriter/web', '_blank',
      0,  VarArrayCreate([0, - 1], varVariant));
      //swriter pour le traitement de texte.
      //scalc pour le tableur
      //sdraw pour l'diteur de dessin
      //simpress pour l'diteur de prsentation (quivalent de PowerPoint)
      //smath pour l'diteur de formule mathmatique
      //swriter/Global Document document maitre
      //swriter/web Pour l'diteur HTML

end;

procedure TForm1.ButtonOuvrirDocumentExistantClick(Sender: TObject);
var
  NomFichier:string;
  OpenOfficeDesktop : Variant;

begin
   if OpenDialog1.Execute then
   begin
     NomFichier:=OpenDialog1.FileName;
     // Openoffice travail avec des nom de fichier au "format" URL
     // il faut donc remplacemer les \ par des /
     // et ajouter devant le chemin 'file:///'
     NomFichier := 'file:///'+StringReplace(NomFichier , '\', '/',[rfReplaceAll]);
       //si on se s'est pas dj connect au serveur, on le fait
     if VarIsEmpty(ServeurOpenOffice) then ServeurOpenOffice:=SeConnecterOpenOffice;
     //On cre une instance OpenOffice
     OpenOfficeDesktop :=
        ServeurOpenOffice.createInstance('com.sun.star.frame.Desktop');
     //On charge le fichier 'NomFichier'
     DocumentOpenOffice :=
        OpenOfficeDesktop.LoadComponentFromURL( NomFichier, '_blank',
        0, VarArrayCreate([0, - 1], varVariant));
   end;
end;

procedure TForm1.RecupererLeTexteClick(Sender: TObject);
var    texte: Variant;
        S:string;
begin
 texte:= DocumentOpenOffice.getText;
 S:=texte.GetString;
 Memo1.Lines.Add(S)
end;

procedure TForm1.ButtonEcriretexteClick(Sender: TObject);
var    texte: Variant;

begin
 texte:= DocumentOpenOffice.getText;
 Texte.setString(Memo1.Text);
end;



procedure TForm1.ButtonEnregistrerSousClick(Sender: TObject);
var NomFichier:String;
begin
  if SaveDialog1.Execute then
  begin
     NomFichier:=saveDialog1.FileName;
     // Openoffice travail avec des nom de fichier au "format" URL
     // il faut donc remplacemer les \ par des /
     // et ajouter devant le chemin 'file:///'
     NomFichier := 'file:///'+StringReplace(NomFichier , '\', '/',[rfReplaceAll]);
       //si on se s'est pas dj connect au serveur, on le fait

    DocumentOpenOffice.storeAsUrl(NomFichier, VarArrayCreate([0, -1], varVariant));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DocumentOpenOffice.Dispose;
end;

procedure TForm1.ButtonImprimerSurimprimantePqarDefautClick(
  Sender: TObject);
begin
begin
  DocumentOpenOffice.print(VarArrayCreate([0, -1], varVariant));
end;
end;

procedure TForm1.ButtonImprimerPage1Et2Click(Sender: TObject);
Var
  MPrinterOpts : variant;
  PropertyValue : Variant;
  CoreReflection : Variant;
begin
   CoreReflection := ServeurOpenOffice.createInstance
                                   ('com.sun.star.reflection.CoreReflection');
   CoreReflection.forName('com.sun.star.beans.PropertyValue')
                                           .createObject(PropertyValue);

  MPrinterOpts := VarArrayCreate([0, 2], varVariant);

// quelles pages  imprimer (ici : de 1  2 on peut aussi : '1-3; 7; 9')
  propertyValue.Name := 'Pages';
  propertyValue.Value := '1-2';
  MPrinterOpts[0] := PropertyValue;

//Nombre d'impressions

  PropertyValue.Name := 'CopyCount';
  PropertyValue.Value := 2;
  MPrinterOpts[1] := PropertyValue;

 // et pour imprimer sur une autre imprimante que celle par dfaut :
 // PropertyValue.Name := 'Name';
 // PropertyValue.Value := 'Nom de l''imprimante';
 // MPrinterOpts[2] := PropertyValue;

  DocumentOpenOffice.print(MPrinterOpts);
end;


end.


